<?php
namespace App\Controller;

use App\Entity\Character;
use App\Entity\Dojo;
use Doctrine\ORM\EntityManagerInterface;
use Symfony\Bundle\SecurityBundle\Security;
use Symfony\Component\HttpKernel\Attribute\AsController;

#[AsController]
final class GetOwnDojoCharacters
{

    public function __construct(private Security $security)
    {}

    public function __invoke(EntityManagerInterface $em): iterable
    {
        $dojo = $em->getRepository(Dojo::class)->findOneByOwner($this->security->getUser());

        return $em->getRepository(Character::class)->findBy([
            'dojo' => $dojo->id
        ]);
    }
}

