<?php
namespace App\Entity;

use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\Common\Collections\Collection;
use Doctrine\ORM\Mapping\Entity;
use Doctrine\ORM\Mapping\JoinColumn;
use Doctrine\ORM\Mapping\OneToMany;
use Doctrine\ORM\Mapping\OneToOne;

#[Entity]
class Country extends Thing
{

    #[OneToOne()]
    #[JoinColumn(onDelete: 'cascade', nullable: false)]
    public City $capital;

    /** @var Prefecture[] */
    #[OneToMany(targetEntity: Prefecture::class, mappedBy: 'prefecture')]
    #[JoinColumn(onDelete: 'cascade', nullable: false)]
    public iterable $prefectures;

    public function __construct()
    {
        $this->prefectures = new ArrayCollection();
    }

    public function getCapital(): ?City
    {
        return $this->capital;
    }

    public function setCapital(City $capital): static
    {
        $this->capital = $capital;

        return $this;
    }

    /**
     * @return Collection<int, Prefecture>
     */
    public function getPrefectures(): Collection
    {
        return $this->prefectures;
    }

    public function addPrefecture(Prefecture $prefecture): static
    {
        if (!$this->prefectures->contains($prefecture)) {
            $this->prefectures->add($prefecture);
            $prefecture->setPrefecture($this);
        }

        return $this;
    }

    public function removePrefecture(Prefecture $prefecture): static
    {
        if ($this->prefectures->removeElement($prefecture)) {
            // set the owning side to null (unless already changed)
            if ($prefecture->getPrefecture() === $this) {
                $prefecture->setPrefecture(null);
            }
        }

        return $this;
    }
}

