<?php
namespace App\State;

use ApiPlatform\Metadata\DeleteOperationInterface;
use ApiPlatform\Metadata\Operation;
use ApiPlatform\State\ProcessorInterface;
use App\Entity\Dojo;
use Psr\Log\LoggerInterface;
use Symfony\Bundle\SecurityBundle\Security;
use Symfony\Component\DependencyInjection\Attribute\Autowire;

/**
 *
 * @implements ProcessorInterface<Dojo, Dojo|void>
 */
class DojoPostProcessor implements ProcessorInterface
{

    public function __construct(
        #[Autowire(service: 'api_platform.doctrine.orm.state.persist_processor')] private ProcessorInterface $persistProcessor,
        #[Autowire(service: 'api_platform.doctrine.orm.state.remove_processor')] private ProcessorInterface $removeProcessor,
        private Security $security, private LoggerInterface $logger)
    {}

    public function process(mixed $data, Operation $operation, array $uriVariables = [], array $context = []): Dojo
    {
        if ($operation instanceof DeleteOperationInterface) {
            return $this->removeProcessor->process($data, $operation, $uriVariables, $context);
        }
        $this->updateDojo($data);
        $result = $this->persistProcessor->process($data, $operation, $uriVariables, $context);

        return $result;
    }

    private function updateDojo(Dojo $dojo): void
    {
        $dojo->setOwner($this->security->getUser());
    }
}
