<?php
namespace App\Validator;

use Symfony\Component\Validator\Constraint;
use Symfony\Component\Validator\ConstraintValidator;
use Symfony\Component\Validator\Exception\UnexpectedValueException;
use DateTimeImmutable;
use DateTimeZone;

class StartDateInFutureValidator extends ConstraintValidator
{

    public function __construct()
    {}

    public function validate(mixed $entity, Constraint $constraint): void
    {
        if (! $constraint instanceof StartDateInFuture) {
            throw new UnexpectedValueException($constraint, CharacterStats::class);
        }

        if ($entity->getStartDate() < new DateTimeImmutable("now", new DateTimeZone("UTC"))) {
            $this->context->buildViolation($constraint->invalidStartDateMessage)->addViolation();
        }
    }
}

